; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Diese Routine stellt ein ASCII-Zeichen auf dem Display dar.					
; INP: temp	(0...127 ASCII, 128...255 inverses ASCII							
;																				
; REGISTER: R0, R1 (werden nicht gesichert)										
;																				
ASCII_TEMP:
	push temp
	push temp1
	push temp2
	push temp9					; Schleife		
	push XL						; Bildspeicher	
	push XH
	push ZL						; Tabelle		
	push ZH
;-------------------------------------------------------------------------------
	LDS temp1,(adr_FONT)
	tst temp1
 	breq ASCII_8x12_TEMP
	rjmp ASCII_16x24_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 8x12 Pixel 16x ASCII pro Zeile												
ASCII_8x12_TEMP:
	ldi ZH, high(FONT_8x12*2)	; Z-; FONT-TABELLE initialisieren
	ldi ZL,  low(FONT_8x12*2)
	ldi temp1,24				; mal 2x12						
	andi temp,0b01111111		; Begrenzung 0...127			
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
; positioieren																	
	ldi XL,LOW (adr_BILD)	; X 
	ldi XH,HIGH(adr_BILD)
	LDS temp,(adr_CURSOR_ZEILE)		; 0...5 
	ldi temp1,(16*(12+1))
	MUL temp,temp1
	add XL,R0
	adc XH,R1
	LDS temp,(adr_CURSOR_SPALTE)	; 0...15
	add XL,temp
	adc XH,NULL
;-------------------------------------------------------------------------------
; Cursor Counter																
	LDS temp,(adr_CURSOR_SPALTE)	; Spalte 0...15		
	inc temp
	cpi temp,16						; >=16	
	brsh ASCII_TEMP_c				; ja	
	STS(adr_CURSOR_SPALTE),temp
	rjmp ASCII_TEMP_CURSOR_FERTIG
ASCII_TEMP_C:
	STS(adr_CURSOR_SPALTE),NULL		; NULL	
	LDS temp,(adr_CURSOR_ZEILE)		; Zeile	0...4		
	inc temp
	cpi temp,5						; >=5	
	brsh ASCII_TEMP_C1				; ja	
	STS(adr_CURSOR_ZEILE),temp
	rjmp ASCII_TEMP_CURSOR_FERTIG
ASCII_TEMP_C1:
	STS(adr_CURSOR_ZEILE),NULL		; NULL	
ASCII_TEMP_CURSOR_FERTIG:
;-------------------------------------------------------------------------------
; ASCII write																	
	ldi temp9,12
ASCII_TEMP_s:
	LPM temp, Z+   					; aus Tabelle laden	
	LPM R0,   Z+ 					; DUMMY				
	rcall ASCII_BITUMKEHR_TEMP		; BIT-UMKEHR		
	ST X,temp
	adiw XL,16
	dec temp9
	brne ASCII_TEMP_s
	rjmp ASCII_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16x24 Pixel 8xASCII pro Zeile
ASCII_16x24_TEMP:
	ldi ZH, high(FONT_8x12*2)	; Z-; FONT-TABELLE initialisieren
	ldi ZL, low (FONT_8x12*2)
	andi temp,0b01111111		; Begrenzung 0...127
	ldi temp1,24				; mal 2x24=48	
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
; positioieren																	
	ldi XL,LOW (adr_BILD)	; X 
	ldi XH,HIGH(adr_BILD)
	LDS temp,(adr_CURSOR_ZEILE)		; Zeile	0...1			
;	subi XL, LOW (-5*16)			; ZEILE 0 positionieren	
;	sbci XH, HIGH(-5*16)
	tst temp 						; Zeile 0?
	breq ASCII_16x24_POS_FERTIG
	subi XL, LOW (-27*16)			; ZEILE 1 positionieren	
	sbci XH, HIGH(-27*16)
ASCII_16x24_POS_FERTIG:
	LDS temp,(adr_CURSOR_SPALTE)	; Spalte 0...7		
	add XL,temp
	adc XH,NULL
	add XL,temp
	adc XH,NULL
;-------------------------------------------------------------------------------
; Cursor Counter																
	LDS temp,(adr_CURSOR_SPALTE)	; Spalte 0...7		
	inc temp
	cpi temp,7+1					; >=8	
	brsh ASCII_16x24_COUNTER0		; ja	
	STS(adr_CURSOR_SPALTE),temp
	rjmp ASCII_16x24_COUNTER_FERTIG
ASCII_16x24_COUNTER0:
	STS(adr_CURSOR_SPALTE),NULL		; NULL	
	LDS temp,(adr_CURSOR_ZEILE)		; Zeile	0...1		
	inc temp
	cpi temp,1+1					; >=2
	brsh ASCII_16x24_COUNTER1		; ja	
	STS(adr_CURSOR_ZEILE),temp
	rjmp ASCII_16x24_COUNTER_FERTIG
ASCII_16x24_COUNTER1:
	STS(adr_CURSOR_ZEILE),NULL		; NULL	
ASCII_16x24_COUNTER_FERTIG:
;-------------------------------------------------------------------------------
; ASCII write																	
	ldi temp9,12
ASCII_16x24_s:
	LPM temp, Z+   					; aus Tabelle laden	
	LPM R0,   Z+
	rcall ASCII_BITUMKEHR_TEMP		; BIT-UMKEHR		
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	rcall ASCII_16x24_VERDOPPLUNG
	ST X+,temp1						; 1. Zeile			
	ST X+,temp2
	adiw XL,14
	ST X+,temp1						; 2. Zeile			
	ST X+,temp2
	adiw XL,14
	dec temp9
	brne ASCII_16x24_s
	rjmp ASCII_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_16x24_VERDOPPLUNG:
	LSL temp
	brcs ASCII_16x24_VERDOPPLUNG_s
	CLC 	; Clear Carry
	ROL temp1
	ROL temp2
	CLC 	; Clear Carry
	ROL temp1
	ROL temp2
	ret
;-------------------------------------------------------------------------------
ASCII_16x24_VERDOPPLUNG_s:
	SEC 	;Set Carry
	ROL temp1
	ROL temp2
	SEC 	;Set Carry
	ROL temp1
	ROL temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	ret
;-------------------------------------------------------------------------------
ASCII_TEXT_w:
	rcall ASCII_TEMP			; Anzeige
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_BITUMKEHR_TEMP:
	MOV R0,temp
	clr temp
	SBRC R0,0
	ori temp,0b10000000
	SBRC R0,1
	ori temp,0b01000000
	SBRC R0,2
	ori temp,0b00100000
	SBRC R0,3
	ori temp,0b00010000
	SBRC R0,4
	ori temp,0b00001000
	SBRC R0,5
	ori temp,0b00000100
	SBRC R0,6
	ori temp,0b00000010
	SBRC R0,7
	ori temp,0b00000001
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_FERTIG:
	pop ZH
	pop ZL
	pop XH
	pop XL
	pop temp9
	pop temp2
	pop temp1
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
CURSOR_POSITION_TEMP1_2:
	STS(adr_CURSOR_SPALTE),temp1
	STS(adr_CURSOR_ZEILE) ,temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_SPACE6:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE5:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE4:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE3:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE2:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE:
	ldi temp,' '
	jmp ASCII_TEMP
; ##############################################################################
ASCII_PUNKT3:
	ldi temp,'.'
	call ASCII_TEMP
ASCII_PUNKT2:
	ldi temp,'.'
	call ASCII_TEMP
ASCII_PUNKT:
	ldi temp,'.'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_DOPPELPUNKT:
	ldi temp,':'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_KOMMA:
	ldi temp,','
	jmp ASCII_TEMP
; ##############################################################################
ASCII_GRD:
	ldi temp,0x07
	jmp ASCII_TEMP
; ##############################################################################
ASCII_PLUS:
	ldi temp,'+'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_MINUS5:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS4:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS3:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS2:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS:
	ldi temp,'-'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_UNTERSTRICH2:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_UNTERSTRICH:
	ldi temp,'-'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_SCHRAEGSTRICH:
	ldi temp,'/'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_FRAGEZEICHEN:
	ldi temp,'?'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_PROZENT:
	ldi temp,'%'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_V:
	ldi temp,'V'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_h_:
	ldi temp,'h'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_ms_:
	ldi temp,'m'
	call ASCII_TEMP
	ldi temp,'s'
	jmp ASCII_TEMP
; ##############################################################################
