; ##############################################################################
; ##############################################################################
; ##############################################################################
; XL = 9 = 0b00001|001															
;        SRAM Byte|Bit															
; Register: Z 			(wird gesichert)										
;			temp, R0,R1 (keine Sicherung, Zeitersparnis)						
PUNKT_SET_XY:
	MOVW ZL_KOPIE,ZL
	tst XH							; berlauf	
	brne PUNKT_SET_EXIT	
	tst YH
	brne PUNKT_SET_EXIT
	cpi XL,128+1
	brsh PUNKT_SET_EXIT
	cpi YL,63+1
	brsh PUNKT_SET_EXIT
;-------------------------------------------------------------------------------
	rcall PUNKT_CALC_X_Y_TEMP
	LD R0,Z							; SRAM read			
	OR R0,temp						; Bitmuster			
	ST Z,R0							; SRAM write		
;-------------------------------------------------------------------------------
PUNKT_SET_EXIT:
	movw ZL,ZL_KOPIE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; XL = 9 = 0b00001|001															
;        SRAM Byte|Bit															
; Register: Z 			(wird gesichert)										
;			temp, R0,R1 (keine Sicherung, Zeitersparnis)						
PUNKT_CLEAR_XY:
	push ZL							; sichern	
	push ZH
	tst XH							; berlauf	
	brne PUNKT_CLEAR_EXIT	
	tst YH
	brne PUNKT_CLEAR_EXIT
	cpi XL,128+1
	brsh PUNKT_CLEAR_EXIT
	cpi YL,63+1
	brsh PUNKT_CLEAR_EXIT
;-------------------------------------------------------------------------------
	rcall PUNKT_CALC_X_Y_TEMP
	LD R0,Z							; SRAM read			
	com temp
	AND R0,temp						; Bitmuster			
	ST Z,R0							; SRAM write		
;-------------------------------------------------------------------------------
PUNKT_CLEAR_EXIT:
	POP ZH							; widerherstellen	
	pop ZL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PUNKT_CALC_X_Y_TEMP:
	ldi ZL,low (adr_BILD+1008)		; Z auf unten links		
	ldi ZH,high(adr_BILD+1008)

	ldi temp,16						; Z auf Zeile Y			
	mul temp,YL
	sub ZL,R0
	sbc ZH,R1

	mov temp,XL						; X-Position SRAM Bytes			
	LSR temp						; oberen 5 Bits herausfiltern	
	LSR temp
	LSR temp
	add ZL,temp						; Z=SRAM-Bytes			
	adc ZH,NULL

	mov temp,XL						; X-Position SRAM Bytes		
	andi temp,0b00000111			; unteren 3 Bits herausfiltern
	cpi temp,0
	breq PUNKT_SET_XY_0
	cpi temp,1
	breq PUNKT_SET_XY_1
	cpi temp,2
	breq PUNKT_SET_XY_2
	cpi temp,3
	breq PUNKT_SET_XY_3
	cpi temp,4
	breq PUNKT_SET_XY_4
	cpi temp,5
	breq PUNKT_SET_XY_5
	cpi temp,6
	breq PUNKT_SET_XY_6
PUNKT_SET_XY_7:
	ldi temp,0b10000000
	ret
PUNKT_SET_XY_6:
	ldi temp,0b01000000
	ret
PUNKT_SET_XY_5:
	ldi temp,0b00100000
	ret
PUNKT_SET_XY_4:
	ldi temp,0b00010000
	ret
PUNKT_SET_XY_3:
	ldi temp,0b00001000
	ret
PUNKT_SET_XY_2:
	ldi temp,0b00000100
	ret
PUNKT_SET_XY_1:
	ldi temp,0b00000010
	ret
PUNKT_SET_XY_0:
	ldi temp,0b00000001
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GRAFIC_TEST_STERNENHIMMEL:
	call ZUFALLSZAHL_TEMP
	andi temp,127
	mov XL,temp
	call ZUFALLSZAHL_TEMP
	andi temp,63
	mov YL,temp
	call PUNKT_SET_XY
ret
	call ZUFALLSZAHL_TEMP
	andi temp,127
	mov XL,temp
	call ZUFALLSZAHL_TEMP
	andi temp,63
	mov YL,temp
	rjmp PUNKT_CLEAR_XY
; ##############################################################################
; ##############################################################################
; ##############################################################################
