; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; 255				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	STS(adr_SRAM_CHECK_A),temp
	STS(adr_SRAM_CHECK_B),temp
	; Zeit				
	ldi temp,0
	STS(adr_hh),temp
	ldi temp,0
	STS(adr_mm),temp
	ldi temp,0
	STS(adr_ss),temp

ret	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Watchdog aktivieren (max. Zeit)												
WDR_INITIALISIERUNG:
	ldi temp,(1<<WDCE)|(1<<WDE)  
	sts WDTCSR,temp       
;WDIF WDIE WDP3 WDCE WDE WDP2 WDP1 WDP0 WDTCSR
	ldi temp,(1<<WDIE)|(1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
;	ldi temp,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	sts WDTCSR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0x00
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH,HIGH(RAMEND-4)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL,LOW (RAMEND-4)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR																
PORT_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)		; ROT		
	call wait_200ms
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	LDS temp,(adr_SRAM_CHECK_A)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	LDS temp,(adr_SRAM_CHECK_B)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER

;	ldi temp,0xFF
;	STS(adr_BILD_BEREICH+0),temp
;	STS(adr_BILD_BEREICH+1023),temp
	ret
; ------------------------------------------------------------------------------
; ROT+GRN blinkt																
PROGRAMM_CHECK_FEHLER:
	CLI 										; Global Interrupt Disable
	LED_ROT_ON
	LED_GELB_OFF
	LED_GRUEN_ON
	call WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	call WAIT_100ms
rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	CLI
	WDR
	call OLED_REFRESH
	LED_GRUEN_ON
	call WAIT_200ms
	LED_GRUEN_OFF
	call WAIT_200ms
	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZUFALLSZAHL_TEMP:
	LDS R3,(TCNT1L)
	add temp,R0
	add temp,R1
	add temp,R2
	add temp,R3
	add temp,R4
	add temp,R5
	add temp,R6
	add temp,R7
	add temp,R8
	add temp,R9
	add temp,R10
	add temp,R11
	add temp,R12
	add temp,R13
	add temp,R14
	add temp,R15
	add temp,XL
	add temp,XH
	add temp,YL
	add temp,YH
	add temp,ZL
	add temp,ZH

	ldi ZL, LOW (0)
	ldi ZH, HIGH(0)
ZUFALLSZAHL_s1:
	LD R0,Z+
	add temp,R0
	cpi ZH,HIGH(RAMEND-4)	; Vergleich?		
	brlo ZUFALLSZAHL_s1		; kleiner => SPRUNG	
	cpi ZL,LOW (RAMEND-4)	; Vergleich?		
	brlo ZUFALLSZAHL_s1		; kleiner => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
MULTIPLIKATION_16_16_32:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	mul	temp4,temp2		; ah * bh
	mov	temp7,r0
	mov	temp8,r1
	mul	temp3,temp1		; al * bl
	mov	temp5,r0
	mov	temp6,r1
	mul	temp4,temp1		; ah * bl
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2
	mul	temp2,temp3		; bh * al
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2


	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne FUNKTION_DIVISION_32_16_RUN
	tst temp6
	brne FUNKTION_DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
FUNKTION_DIVISION_32_16_RUN:
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
FUNKTION_DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    FUNKTION_DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    FUNKTION_DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
FUNKTION_DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
FUNKTION_DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    FUNKTION_DIVISION_32_16_1
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 07/2015																
;																				
;	Division 16 bit-Zahl durch 8 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)													
;	input/Output 	temp2 (HIGH)												
;																				
;	input			temp3	Divisor		 										
;																				
DIVISION_16_8:
;-----------------------------------------------------------------------
	; NULL-CHECK				
	tst temp3
	brne FUNKTION_DIVISION_16_8_RUN
	clr temp1
	clr temp2
	ret
;-----------------------------------------------------------------------
FUNKTION_DIVISION_16_8_RUN:
	; Hilfsregister sichern		
	push temp6
	push temp7
;-----------------------------------------------------------------------
	; Aufrunden halben Divisor dazuaddieren	
	mov temp,temp3
	LSR temp	
	add temp1,temp
	adc temp2,NULL
;-----------------------------------------------------------------------
	clr temp 			; Leere Hilfsregister
	ldi temp6,1			; Zhler Bit 1 auf 1 setzen)
	clr temp7
;-----------------------------------------------------------------------
div8a:
	clc 				; Carry-Bit leeren
	rol temp1 		
	rol temp2 		
	rol temp 			;  in das Hilfsregister rotieren		
	brcs div8b 			; Eine 1 ist herausgerollt, ziehe ab	
	cp temp,temp3 		; Divisionsergebnis 1 oder 0?			
	brcs div8c 			; berspringe Subtraktion, wenn kleiner	
div8b:
	sub temp,temp3	 	; Subtrahiere Divisor					
	sec 				; Setze carry-bit, Ergebnis ist eine 1	
	rjmp div8d 			
div8c:
	clc 				; Lsche carry-bit, Ergebnis ist eine 0
div8d:
	rol temp6 			; Rotiere carry-bit in das Ergebnis		
	rol temp7
	brcc div8a 			; solange Nullen aus dem Ergebnis rotieren: weitermachen
;-----------------------------------------------------------------------
	;Zurckschreiben	
	mov temp1, temp6
	mov temp2, temp7
;-----------------------------------------------------------------------
	; wieder herstellen	
	pop temp7
	pop temp6
ret
;########################################################################
;########################################################################
;########################################################################


