; ##############################################################################
; ##############################################################################
; ##############################################################################
; 8-BIT-TIMER																	
;																				
; CS22 CS21 CS20																
;	0 	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/(No prescaling)											
;	0 	1 	0 	clkT2S/8 (From prescaler)										
;	0 	1 	1 	clkT2S/32 (From prescaler)										
;  *1 	0 	0 	clkT2S/64 (From prescaler)										
;	1 	0 	1 	clkT2S/128 (From prescaler)										
;	1 	1 	0 	clkT2S/256 (From prescaler)										
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
;																				
TIMER2_1ms_INITIALISIERUNG:
.equ TIMERWERT2 					=256-125		; (2 hoch 8  minus...) 8MHz VT:64--->125
	; TCCR2B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC2A)| (0<<FOC2B)|(1<<CS22)|(0<<CS21)|(0<<CS20)
	STS TCCR2B,temp
	; TIMSK2  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE2B)| (0<<OCIE2A)|(1<<TOIE2)
	STS TIMSK2,temp
	; STARTWERT										
	ldi temp,(TIMERWERT2)
	STS TCNT2,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1ms																			
TIM2_OVF:
	push TEMP		    	; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG			; Einlesen des SREG 					
	push TEMP	    		; Schreiben von  SREG  im Stack (KOPIE)	
	push TEMP1
;-------------------------------------------------------------------------------
	ldi temp,(TIMERWERT2)
	STS TCNT2,temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_STOP_UHR_L)
	LDS temp1,(adr_STOP_UHR_H)
	add temp,EINS
	adc temp1,NULL
	STS(adr_STOP_UHR_L),temp
	STS(adr_STOP_UHR_H),temp1
TIM2_OVF_w:
;-------------------------------------------------------------------------------
; UHR-ms (Millisekunden)														
	LDS temp,(adr_1ms)
	inc temp
	cpi temp,10
	brsh TIM2_10ms
	STS(adr_1ms),temp
	rjmp TIM2_OVF_FERTIG
TIM2_10ms:
	STS(adr_1ms),NULL	; NULL	
	LDS temp,(adr_10ms)
	inc temp
	cpi temp,10
	brsh TIM2_100ms
	STS(adr_10ms),temp
	rjmp TIM2_OVF_FERTIG
TIM2_100ms:
	STS(adr_10ms),NULL	; NULL	
	LDS temp,(adr_100ms)
	inc temp
	cpi temp,10
	brsh TIM2_1s
	STS(adr_100ms),temp
	rjmp TIM2_OVF_FERTIG
;-------------------------------------------------------------------------------
TIM2_1s:
	STS(adr_100ms),NULL	; NULL	

	rcall UHR				; UHR
;-------------------------------------------------------------------------------
TIM2_OVF_FERTIG:
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 		
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR:
	LDS temp,(adr_ss)
	inc temp
	STS (adr_ss),temp
	cpi temp,60
	brsh UHR_mm
	ret	
;-------------------------------------------------------------------------------
UHR_mm:
	STS (adr_ss),NULL	; NULL	


	LDS temp,(adr_mm)
	inc temp
	STS (adr_mm),temp
	cpi temp,60
	brsh UHR_hh
	ret	
;-------------------------------------------------------------------------------
UHR_hh:
	STS (adr_mm),NULL	; NULL	

	LDS temp,(adr_hh)
	inc temp
	STS (adr_hh),temp
	cpi temp,24
	brsh UHR_TAG
	ret	
;-------------------------------------------------------------------------------
UHR_TAG:
	STS (adr_hh),NULL	; NULL	
ret
;###################################################################
;###################################################################
;###################################################################


